/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MSG
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_msg.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static void *
alloc_msgs()
{
	return xcalloc(NMSGS, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + NMSGS; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg && tab[i].current) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 48

#line 48
static int MSGTAB_id;
#line 48 "bi_msg.m4"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 123


#line 134


#line 145


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 150
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 150
	struct mf_message *mp;
#line 150
			
#line 150
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 150
			env_throw_bi(env, mfe_range, NULL, _("Invalid message descriptor"))
#line 150
;
#line 150
	mp = mtab + nmsg;
#line 150
		if (!(mp->msg))
#line 150
			env_throw_bi(env, mfe_failure, NULL, _("Message not open"))
#line 150

#line 150
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 155
bi_message_close(eval_environ_t env)
#line 155

#line 155 "bi_msg.m4"
{
#line 155
	
#line 155

#line 155

#line 155
long  nmsg;
#line 155
        
#line 155
get_numeric_arg(env, 0, &nmsg);
#line 155
        
#line 155

#line 155
        adjust_stack(env, 1);
#line 155

#line 155
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 155
		prog_trace(env, "message_close %lu",nmsg);;
#line 155

{
	
#line 157
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 157
	struct mf_message *mp;
#line 157
			
#line 157
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 157
			env_throw_bi(env, mfe_range, "message_close", _("Invalid message descriptor"))
#line 157
;
#line 157
	mp = mtab + nmsg;
#line 157
		if (!(mp->msg))
#line 157
			env_throw_bi(env, mfe_failure, "message_close", _("Message not open"))
#line 157

#line 157
;
	bi_close_message(mp);
}
}

/* number message_size(number nmsg) */
void
#line 163
bi_message_size(eval_environ_t env)
#line 163

#line 163 "bi_msg.m4"
{
#line 163
	
#line 163

#line 163

#line 163
long  nmsg;
#line 163
        
#line 163
get_numeric_arg(env, 0, &nmsg);
#line 163
        
#line 163

#line 163
        adjust_stack(env, 1);
#line 163

#line 163
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 163
		prog_trace(env, "message_size %lu",nmsg);;
#line 163

{
	int rc;
	size_t size;
	
#line 167
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 167
	struct mf_message *mp;
#line 167
			
#line 167
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 167
			env_throw_bi(env, mfe_range, "message_size", _("Invalid message descriptor"))
#line 167
;
#line 167
	mp = mtab + nmsg;
#line 167
		if (!(mp->msg))
#line 167
			env_throw_bi(env, mfe_failure, "message_size", _("Message not open"))
#line 167

#line 167
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 170
			env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 172
;
		if (!(size < LONG_MAX))
#line 173
			env_throw_bi(env, mfe_range, "message_size", _("Message size out of representable range"))
#line 175
;
	
#line 176
do {
#line 176
  push(env, (STKVAL) ((long)size));
#line 176
  return;
#line 176
} while (0);
}	
}

/* number message_lines(number nmsg) */
void
#line 181
bi_message_lines(eval_environ_t env)
#line 181

#line 181 "bi_msg.m4"
{
#line 181
	
#line 181

#line 181

#line 181
long  nmsg;
#line 181
        
#line 181
get_numeric_arg(env, 0, &nmsg);
#line 181
        
#line 181

#line 181
        adjust_stack(env, 1);
#line 181

#line 181
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 181
		prog_trace(env, "message_lines %lu",nmsg);;
#line 181

{
	int rc;
	size_t lines;
	
#line 185
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 185
	struct mf_message *mp;
#line 185
			
#line 185
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 185
			env_throw_bi(env, mfe_range, "message_lines", _("Invalid message descriptor"))
#line 185
;
#line 185
	mp = mtab + nmsg;
#line 185
		if (!(mp->msg))
#line 185
			env_throw_bi(env, mfe_failure, "message_lines", _("Message not open"))
#line 185

#line 185
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 188
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 191
;
	
#line 192
do {
#line 192
  push(env, (STKVAL) (lines));
#line 192
  return;
#line 192
} while (0);
}
}

/* number message_body_size(number nmsg) */
void
#line 197
bi_message_body_size(eval_environ_t env)
#line 197

#line 197 "bi_msg.m4"
{
#line 197
	
#line 197

#line 197

#line 197
long  nmsg;
#line 197
        
#line 197
get_numeric_arg(env, 0, &nmsg);
#line 197
        
#line 197

#line 197
        adjust_stack(env, 1);
#line 197

#line 197
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 197
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 197

{
	int rc;
	size_t size;
	
#line 201
	
#line 201
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 201
	struct mf_message *mp;
#line 201
			
#line 201
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 201
			env_throw_bi(env, mfe_range, "message_body_size", _("Invalid message descriptor"))
#line 201
;
#line 201
	mp = mtab + nmsg;
#line 201
		if (!(mp->msg))
#line 201
			env_throw_bi(env, mfe_failure, "message_body_size", _("Message not open"))
#line 201

#line 201
;
#line 201
	if (!mp->body) {
#line 201
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 201
			if (!(rc == 0))
#line 201
			env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 201
;
#line 201
	}	  
#line 201
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 204
			env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 206
;
		if (!(size < LONG_MAX))
#line 207
			env_throw_bi(env, mfe_range, "message_body_size", _("Body size out of representable range"))
#line 209
;
	
#line 210
do {
#line 210
  push(env, (STKVAL) ((long)size));
#line 210
  return;
#line 210
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 215
bi_message_body_lines(eval_environ_t env)
#line 215

#line 215 "bi_msg.m4"
{
#line 215
	
#line 215

#line 215

#line 215
long  nmsg;
#line 215
        
#line 215
get_numeric_arg(env, 0, &nmsg);
#line 215
        
#line 215

#line 215
        adjust_stack(env, 1);
#line 215

#line 215
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 215
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 215

{
	int rc;
	size_t lines;
	
#line 219
	
#line 219
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 219
	struct mf_message *mp;
#line 219
			
#line 219
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 219
			env_throw_bi(env, mfe_range, "message_body_lines", _("Invalid message descriptor"))
#line 219
;
#line 219
	mp = mtab + nmsg;
#line 219
		if (!(mp->msg))
#line 219
			env_throw_bi(env, mfe_failure, "message_body_lines", _("Message not open"))
#line 219

#line 219
;
#line 219
	if (!mp->body) {
#line 219
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 219
			if (!(rc == 0))
#line 219
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 219
;
#line 219
	}	  
#line 219
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 222
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 225
;
	
#line 226
do {
#line 226
  push(env, (STKVAL) (lines));
#line 226
  return;
#line 226
} while (0);
}
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 234
bi_message_header_size(eval_environ_t env)
#line 234

#line 234 "bi_msg.m4"
{
#line 234
	
#line 234

#line 234

#line 234
long  nmsg;
#line 234
        
#line 234
get_numeric_arg(env, 0, &nmsg);
#line 234
        
#line 234

#line 234
        adjust_stack(env, 1);
#line 234

#line 234
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 234
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 234

{
	int rc;
	size_t size;
	
#line 238
	
#line 238
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 238
	struct mf_message *mp;
#line 238
			
#line 238
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 238
			env_throw_bi(env, mfe_range, "message_header_size", _("Invalid message descriptor"))
#line 238
;
#line 238
	mp = mtab + nmsg;
#line 238
		if (!(mp->msg))
#line 238
			env_throw_bi(env, mfe_failure, "message_header_size", _("Message not open"))
#line 238

#line 238
;
#line 238
	if (!mp->hdr) {
#line 238
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 238
			if (!(rc == 0))
#line 238
			env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 238
;
#line 238
	}	  
#line 238
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 241
			env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 243
;
		if (!(size < LONG_MAX))
#line 244
			env_throw_bi(env, mfe_range, "message_header_size", _("Header size out of representable range"))
#line 246
;
	
#line 247
do {
#line 247
  push(env, (STKVAL) ((long)size));
#line 247
  return;
#line 247
} while (0);
}
}

/* number message_header_lines(number nmsg) */
void
#line 252
bi_message_header_lines(eval_environ_t env)
#line 252

#line 252 "bi_msg.m4"
{
#line 252
	
#line 252

#line 252

#line 252
long  nmsg;
#line 252
        
#line 252
get_numeric_arg(env, 0, &nmsg);
#line 252
        
#line 252

#line 252
        adjust_stack(env, 1);
#line 252

#line 252
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 252
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 252

{
	int rc;
	size_t lines;
	
#line 256
	
#line 256
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 256
	struct mf_message *mp;
#line 256
			
#line 256
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 256
			env_throw_bi(env, mfe_range, "message_header_lines", _("Invalid message descriptor"))
#line 256
;
#line 256
	mp = mtab + nmsg;
#line 256
		if (!(mp->msg))
#line 256
			env_throw_bi(env, mfe_failure, "message_header_lines", _("Message not open"))
#line 256

#line 256
;
#line 256
	if (!mp->hdr) {
#line 256
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 256
			if (!(rc == 0))
#line 256
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 256
;
#line 256
	}	  
#line 256
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 259
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 262
;
	
#line 263
do {
#line 263
  push(env, (STKVAL) (lines));
#line 263
  return;
#line 263
} while (0);
}
}

/* number message_header_count(number nmsg) */
void
#line 268
bi_message_header_count(eval_environ_t env)
#line 268

#line 268 "bi_msg.m4"
{
#line 268
	
#line 268

#line 268

#line 268
long  nmsg;
#line 268
        
#line 268
get_numeric_arg(env, 0, &nmsg);
#line 268
        
#line 268

#line 268
        adjust_stack(env, 1);
#line 268

#line 268
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 268
		prog_trace(env, "message_header_count %lu",nmsg);;
#line 268

{
	int rc;
	size_t count;
	
#line 272
	
#line 272
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 272
	struct mf_message *mp;
#line 272
			
#line 272
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 272
			env_throw_bi(env, mfe_range, "message_header_count", _("Invalid message descriptor"))
#line 272
;
#line 272
	mp = mtab + nmsg;
#line 272
		if (!(mp->msg))
#line 272
			env_throw_bi(env, mfe_failure, "message_header_count", _("Message not open"))
#line 272

#line 272
;
#line 272
	if (!mp->hdr) {
#line 272
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 272
			if (!(rc == 0))
#line 272
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 272
;
#line 272
	}	  
#line 272
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 275
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 278
;
	
#line 279
do {
#line 279
  push(env, (STKVAL) (count));
#line 279
  return;
#line 279
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 284
bi_message_has_header(eval_environ_t env)
#line 284

#line 284 "bi_msg.m4"
{
#line 284
	
#line 284

#line 284
long __bi_argcnt;
#line 284
long  nmsg;
#line 284
        char * header;
#line 284
        long  idx;
#line 284
        
#line 284
get_numeric_arg(env, 1, &nmsg);
#line 284
        get_string_arg(env, 2, &header);
#line 284
        get_numeric_arg(env, 3, &idx);
#line 284
        
#line 284
get_numeric_arg(env, 0, &__bi_argcnt);
#line 284
        adjust_stack(env, __bi_argcnt + 1);
#line 284

#line 284
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 284
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 289
	
#line 289
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 289
	struct mf_message *mp;
#line 289
			
#line 289
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 289
			env_throw_bi(env, mfe_range, "message_has_header", _("Invalid message descriptor"))
#line 289
;
#line 289
	mp = mtab + nmsg;
#line 289
		if (!(mp->msg))
#line 289
			env_throw_bi(env, mfe_failure, "message_has_header", _("Message not open"))
#line 289

#line 289
;
#line 289
	if (!mp->hdr) {
#line 289
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 289
			if (!(rc == 0))
#line 289
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 289
;
#line 289
	}	  
#line 289
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 292
do {
#line 292
  push(env, (STKVAL) (rc == 0));
#line 292
  return;
#line 292
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 297
bi_message_find_header(eval_environ_t env)
#line 297

#line 297 "bi_msg.m4"
{
#line 297
	
#line 297

#line 297
long __bi_argcnt;
#line 297
long  nmsg;
#line 297
        char * header;
#line 297
        long  idx;
#line 297
        
#line 297
get_numeric_arg(env, 1, &nmsg);
#line 297
        get_string_arg(env, 2, &header);
#line 297
        get_numeric_arg(env, 3, &idx);
#line 297
        
#line 297
get_numeric_arg(env, 0, &__bi_argcnt);
#line 297
        adjust_stack(env, __bi_argcnt + 1);
#line 297

#line 297
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 297
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 302
	
#line 302
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 302
	struct mf_message *mp;
#line 302
			
#line 302
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 302
			env_throw_bi(env, mfe_range, "message_find_header", _("Invalid message descriptor"))
#line 302
;
#line 302
	mp = mtab + nmsg;
#line 302
		if (!(mp->msg))
#line 302
			env_throw_bi(env, mfe_failure, "message_find_header", _("Message not open"))
#line 302

#line 302
;
#line 302
	if (!mp->hdr) {
#line 302
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 302
			if (!(rc == 0))
#line 302
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 302
;
#line 302
	}	  
#line 302
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("Header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 309
return;
#line 309
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 317
bi_message_is_multipart(eval_environ_t env)
#line 317

#line 317 "bi_msg.m4"
{
#line 317
	
#line 317

#line 317

#line 317
long  nmsg;
#line 317
        
#line 317
get_numeric_arg(env, 0, &nmsg);
#line 317
        
#line 317

#line 317
        adjust_stack(env, 1);
#line 317

#line 317
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 317
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 317

{
	int rc, res;
	
#line 320
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 320
	struct mf_message *mp;
#line 320
			
#line 320
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 320
			env_throw_bi(env, mfe_range, "message_is_multipart", _("Invalid message descriptor"))
#line 320
;
#line 320
	mp = mtab + nmsg;
#line 320
		if (!(mp->msg))
#line 320
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("Message not open"))
#line 320

#line 320
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 323
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 326
;
	
#line 327
do {
#line 327
  push(env, (STKVAL) (res));
#line 327
  return;
#line 327
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 332
bi_message_count_parts(eval_environ_t env)
#line 332

#line 332 "bi_msg.m4"
{
#line 332
	
#line 332

#line 332

#line 332
long  nmsg;
#line 332
        
#line 332
get_numeric_arg(env, 0, &nmsg);
#line 332
        
#line 332

#line 332
        adjust_stack(env, 1);
#line 332

#line 332
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 332
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 332

{
	int rc;
	size_t count;
	
#line 336
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 336
	struct mf_message *mp;
#line 336
			
#line 336
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 336
			env_throw_bi(env, mfe_range, "message_count_parts", _("Invalid message descriptor"))
#line 336
;
#line 336
	mp = mtab + nmsg;
#line 336
		if (!(mp->msg))
#line 336
			env_throw_bi(env, mfe_failure, "message_count_parts", _("Message not open"))
#line 336

#line 336
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 338
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 341
;
	
#line 342
do {
#line 342
  push(env, (STKVAL) (count));
#line 342
  return;
#line 342
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 347
bi_message_get_part(eval_environ_t env)
#line 347

#line 347 "bi_msg.m4"
{
#line 347
	
#line 347

#line 347

#line 347
long  nmsg;
#line 347
        long  idx;
#line 347
        
#line 347
get_numeric_arg(env, 0, &nmsg);
#line 347
        get_numeric_arg(env, 1, &idx);
#line 347
        
#line 347

#line 347
        adjust_stack(env, 2);
#line 347

#line 347
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 347
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 347

{
	int rc;
	mu_message_t msg;
	
#line 351
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 351
	struct mf_message *mp;
#line 351
			
#line 351
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 351
			env_throw_bi(env, mfe_range, "message_get_part", _("Invalid message descriptor"))
#line 351
;
#line 351
	mp = mtab + nmsg;
#line 351
		if (!(mp->msg))
#line 351
			env_throw_bi(env, mfe_failure, "message_get_part", _("Message not open"))
#line 351

#line 351
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 354
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 357
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 359
			env_throw_bi(env, mfe_failure, "message_get_part", _("No more message slots available"))
#line 361
;
	
#line 362
do {
#line 362
  push(env, (STKVAL) (rc));
#line 362
  return;
#line 362
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 370
bi_message_rewind(eval_environ_t env)
#line 370

#line 370 "bi_msg.m4"
{
#line 370
	
#line 370

#line 370

#line 370
long  nmsg;
#line 370
        
#line 370
get_numeric_arg(env, 0, &nmsg);
#line 370
        
#line 370

#line 370
        adjust_stack(env, 1);
#line 370

#line 370
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 370
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 370

{
	int rc;
	mu_stream_t str;
	
#line 374
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 374
	struct mf_message *mp;
#line 374
			
#line 374
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 374
			env_throw_bi(env, mfe_range, "message_rewind", _("Invalid message descriptor"))
#line 374
;
#line 374
	mp = mtab + nmsg;
#line 374
		if (!(mp->msg))
#line 374
			env_throw_bi(env, mfe_failure, "message_rewind", _("Message not open"))
#line 374

#line 374
;
	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 376
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 379
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 381
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 384
;
}
}

/* string message_read_line(number nmsg) */
void
#line 389
bi_message_read_line(eval_environ_t env)
#line 389

#line 389 "bi_msg.m4"
{
#line 389
	
#line 389

#line 389

#line 389
long  nmsg;
#line 389
        
#line 389
get_numeric_arg(env, 0, &nmsg);
#line 389
        
#line 389

#line 389
        adjust_stack(env, 1);
#line 389

#line 389
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 389
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 389

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 394
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 394
	struct mf_message *mp;
#line 394
			
#line 394
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 394
			env_throw_bi(env, mfe_range, "message_read_line", _("Invalid message descriptor"))
#line 394
;
#line 394
	mp = mtab + nmsg;
#line 394
		if (!(mp->msg))
#line 394
			env_throw_bi(env, mfe_failure, "message_read_line", _("Message not open"))
#line 394

#line 394
;

	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 397
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 400
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 402
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 405
;
		if (!(size > 0))
#line 406
			env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_sequential_getline: %s",_("end of input"))
#line 409
;
	do {pushs(env, mp->buf);
#line 410
return;
#line 410
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 415
bi_message_body_rewind(eval_environ_t env)
#line 415

#line 415 "bi_msg.m4"
{
#line 415
	
#line 415

#line 415

#line 415
long  nmsg;
#line 415
        
#line 415
get_numeric_arg(env, 0, &nmsg);
#line 415
        
#line 415

#line 415
        adjust_stack(env, 1);
#line 415

#line 415
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 415
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 415

{
	int rc;
	mu_stream_t str;
	
#line 419
	
#line 419
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 419
	struct mf_message *mp;
#line 419
			
#line 419
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 419
			env_throw_bi(env, mfe_range, "message_body_rewind", _("Invalid message descriptor"))
#line 419
;
#line 419
	mp = mtab + nmsg;
#line 419
		if (!(mp->msg))
#line 419
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("Message not open"))
#line 419

#line 419
;
#line 419
	if (!mp->body) {
#line 419
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 419
			if (!(rc == 0))
#line 419
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 419
;
#line 419
	}	  
#line 419
;
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 421
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 424
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 426
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 429
;
}
}

/* string message_read_body_line(number msg)  */
void
#line 434
bi_message_read_body_line(eval_environ_t env)
#line 434

#line 434 "bi_msg.m4"
{
#line 434
	
#line 434

#line 434

#line 434
long  nmsg;
#line 434
        
#line 434
get_numeric_arg(env, 0, &nmsg);
#line 434
        
#line 434

#line 434
        adjust_stack(env, 1);
#line 434

#line 434
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 434
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 434

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 439
	
#line 439
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 439
	struct mf_message *mp;
#line 439
			
#line 439
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 439
			env_throw_bi(env, mfe_range, "message_read_body_line", _("Invalid message descriptor"))
#line 439
;
#line 439
	mp = mtab + nmsg;
#line 439
		if (!(mp->msg))
#line 439
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("Message not open"))
#line 439

#line 439
;
#line 439
	if (!mp->body) {
#line 439
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 439
			if (!(rc == 0))
#line 439
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 439
;
#line 439
	}	  
#line 439
;
	
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 442
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 445
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 447
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 450
;
		if (!(size > 0))
#line 451
			env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_sequential_getline: %s",_("end of input"))
#line 454
;
	do {pushs(env, mp->buf);
#line 455
return;
#line 455
} while (0);
}
}


#line 459
void
#line 459
msg_init_builtin()
#line 459
{
#line 459
	#line 48 "bi_msg.m4"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 48
drop_current_message);
#line 155 "bi_msg.m4"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 163 "bi_msg.m4"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 181 "bi_msg.m4"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 197 "bi_msg.m4"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 215 "bi_msg.m4"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 234 "bi_msg.m4"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 252 "bi_msg.m4"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 268 "bi_msg.m4"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 284 "bi_msg.m4"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 297 "bi_msg.m4"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 317 "bi_msg.m4"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 332 "bi_msg.m4"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 347 "bi_msg.m4"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 370 "bi_msg.m4"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 389 "bi_msg.m4"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 415 "bi_msg.m4"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 434 "bi_msg.m4"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);

#line 459 "bi_msg.m4"
	
#line 459
}
#line 459

#line 627 "../mfd/snarf.m4"

#line 627

